//'WWWW'WWW''''''''WW''''''''WWW''WW''W'''''''''''''''''''''''''WWW'''''''
//WW  W  WW        WW         WW  WW  W                          WW       
//WW     WW   WW   WWW   WWW  WW  WW  W  WWW W WW  WWWW     WWW  WW   WWW 
//WW WW  WW  WW W  WW W W WW  WW  WW  W W WW WW   WWW      WW W  WW  W WW 
//WW  W  WW  WW W  WW W W WW  WW  WW W  W WW WW     WWW    WW    WW  W WW 
// WWWW WWWW  WW   WWW   WWW WWWW  WW    WWW WW   WWWW      WWW WWWW  WWW 
//                                                                        
//''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

#ifndef GLOBALVARS
#define GLOBALVARS

#include "Main.h"

class Pane;       // forward declaration of Pane class
class CameraList; // forward declaration of CameraList class

typedef struct timeRecord_st {
  int render;
  clock_t renderTicks;
  int totalTime;
  clock_t totalTicks;
  int octreeCreation;
  int photonShooting;
  int photonBalancing;
  int photonIrradiance;
} timeRecord_t;

class GlobalVars {
private:
public:
  char *sceneFile;
  char *imgFile;
  char *inImgFile;
  char *ivOutFile;
  int imgDim[2];
  double imgMin[2], imgMax[2];
  int headLightPos;
  int renderQuit;
  int algorithm;
  int numSamples;
  int maxDepth;
  int octreeDebug;
  int octreeMaxDepth;
  int octreeMaxItems;
  float luminanceMean;
  timeRecord_t times;
  int lightSamples;
  int totalLightSamples;
  int debugPixel[2];
  int debugRange;
  int animateScene;
  int areaLights;
  int automaticUpdate;
  int createBackup;
  int allowReflection;
  string cmdLine;
  double unitsPerMeter;
  double metersPerUnit;
  double metersPerUnit2;
  double samples[100];
  SbColor windowBG;
  SbColor worldBG;
  SoSeparator *root;     // root of scenegraph
  SoSeparator *scene;    // scene that is rendered (child of root)
  SoTransform *trans;    // transform at head of scenegraph
  SoSwitch *sceneSwitch; // turns off scene
  SoSwitch *crossSwitch; // turns off crosshair
  SoCamera *cam;         // points to Examiner viewer camera
  Pane *pane;            // points to pane rendering object
  CameraList *camList;   // points to CameraList for camera movement
  SoXtExaminerViewer *xtViewer;
  int gPhotonEstimate;
  int cPhotonEstimate;
  int iPhotonEstimate;
  int numPhotons;
  int numCPhotons;
  int numIPhotons;
  int approximate;
  double irradCacheError;
  int showPhotons;
  int toneMapping;
  int renderFlags;
  int gatherRays;
  int precomputeIrr;
  int fastTransparency;
  int numThreads;
  int nonRandomPixels;
  int quasiRandom;
  float ambientResolution;
  float refractionIndex;
  int tempInt;
  float tempFloat;
  int floatMap;
  float maxRelError;
  float timeVal;
  int frames;
  int rrStartDepth;
  int sceneHasShininess;
  int sceneHasLights;
  int seeSingleSided;
  int useGlassModel;
  int renderIv;
  int useDimensions;
  int figureMode;
  int showNormals;
  float gamma;
  float exposure;
  char *comment;
  float aperture;
  float transpScale;
  char *environMapFile;
  char *envMapFile;
  int envMapDims[2];
  char *sampleMap;
  int silent;
  int useEmisFluxDensity;
  int computeNormals;
  int useGlare;
  int srandSeed;
  int simpleOctree;
  int prepass;
  int makeMatte;
  float envMapRotation;
  SbColor attenuation;
  int useIndirectImpSampling;
  float sigma_s;
  float stepsize;
  int bumpMapping;
  float bumpScale;
  int useIrradCache;
  
  // thread stuff
  static const int maxThreads=32;
  pthread_t threads[maxThreads];
  sem_t glob_sema[maxThreads];

  GlobalVars();
  void readOpts(int argc, char *argv[]);
  void printUsage(int version=0);

  double meters(double units){
    return(units*metersPerUnit);
  }
  double meters2(double units){
    return(units*metersPerUnit2);
  }
  double units(double meters){
    return(meters*unitsPerMeter);
  }
};

#endif /* GLOBALVARS */
