#include <Inventor/actions/SoCallbackAction.h>
#include <Inventor/actions/SoGLRenderAction.h>
#include "MatPlus.h"

SO_NODE_SOURCE(MatPlus);

void MatPlus::initClass(){
  SO_NODE_INIT_CLASS(MatPlus, SoNode, "Node");
}

// constructor
MatPlus::MatPlus(){
  SO_NODE_CONSTRUCTOR(MatPlus);

  SO_NODE_ADD_FIELD(model, (SCHLICK));
  
  SO_NODE_DEFINE_ENUM_VALUE(ReflModel, SCHLICK);
  SO_NODE_DEFINE_ENUM_VALUE(ReflModel, DATA);
  SO_NODE_DEFINE_ENUM_VALUE(ReflModel, LIBRARY);
  
  SO_NODE_SET_SF_ENUM_TYPE(model, ReflModel);
  
  SO_NODE_ADD_FIELD(rough1, (1.0));
  SO_NODE_ADD_FIELD(rough2, (1.0));
  SO_NODE_ADD_FIELD(sym1, (1.0));
  SO_NODE_ADD_FIELD(sym2, (1.0));
  SO_NODE_ADD_FIELD(R0, (1.0));
  SO_NODE_ADD_FIELD(layers, (1));

  /*
  SoSFFloat rough1, rough2;  // roughness  (0=mirror, 1=diffuse (default))
  SoSFFloat sym1, sym2;      // anisotropy
                             // (0=aniisotropic, 1=isotropic (symmetrical, default))
  SoSFFloat R0;              // reflection at normal incidence
                             // Default: 1
                             // -1 means auto-alculated based on index of refractions

  SoSFInt layers;            // 1 (default) or 2
  //SoSFVec2f g, s, d;         // internal (private, automatically calculated)
  */

  //SO_NODE_ADD_FIELD(transparency, (0.0));
  SO_NODE_ADD_FIELD(ior1, (1.0));
  SO_NODE_ADD_FIELD(ior2, (1.5));
  SO_NODE_ADD_FIELD(atten, (0.98, 0.99, 0.98));

  SO_NODE_ADD_FIELD(emisEcc, (1.0));
  SO_NODE_ADD_FIELD(minDist, (0.0001));

  /*
  float transparency; // 0 (opaque, default) - 1 (clear)
  SoSFFloat ior1;     // OUTSIDE index of refraction Default: 1.0 (air)
  SoSFFloat ior2;     // INSIDE index of refraction Default: 1.5 (glass)
  SoSFColor atten;    // attenuation (fraction) at 1m when going through inside
                      // Default (0.98, 0.99, 0.98)
                      // from specularColor ?
  */

  isBuiltIn = TRUE;
}

MatPlus::~MatPlus(){
}

void MatPlus::GLRender(SoGLRenderAction *action){
  doAction(action);
}

void MatPlus::callback(SoCallbackAction *action){
  doAction(action);
}

void MatPlus::doAction(SoAction *action){
  cerr << "hi from MatPlus::doAction\n";
}

int matplus_main(int argc, char *argv[]){
  MatPlus hi;
  cerr << "hiii\n";
  return(0);
}
