//WWWW''WW'''W''WWWW'''''''''WWW''''''''''''''''''
//WW  W WWW  W WW  W          WW                  
//WW  W W WW W WW        WWW  WW   WWW  WWWW  WWWW
//WWWW  W  WWW WW WW    WW W  WW  W WW WWW   WWW  
//WW  W W   WW WW  W    WW    WW  W WW   WWW   WWW
//WW  W W    W  WWWW     WWW WWWW  WWW WWWW  WWWW 
//                                                
//''''''''''''''''''''''''''''''''''''''''''''''''
// Random Number Generator class
// mostly out of Realistic Ray Tracing 2nd Ed.
// Uses a linear congruence algorithm.

#ifndef RNGCLASS
#define RNGCLASS

typedef unsigned long long ull_t;
class RNG {

  public:

  RNG(unsigned long long _seed = 7564231ULL){
    seed = _seed;
    mult = 62089911ULL;
    llong_max = 4294967295ULL;
    float_max = 4294967295.0f;
  }

  float operator()();
  void setSeed(unsigned long long _seed = 7564231ULL);
  
  unsigned long long seed;
  unsigned long long mult;
  unsigned long long llong_max;
  float float_max;
};

inline float RNG::operator()(){
  seed = mult * seed;
  return float(seed % llong_max) / float_max;
}

inline void RNG::setSeed(unsigned long long _seed){
  seed = _seed;
}

#endif /* RNGCLASS */

