
//WWWWWW'''''''''''''WW'''''''''''''''''''''''''WWW''''''''''''''''''
//  WW               WW                          WW                  
//  WW     WW  WW W WWWW W WW W WW  WW      WWW  WW   WWW  WWWW  WWWW
//  WW    WWWW  WW   WW  W WW WW   WWWW    WW W  WW  W WW WWW   WWW  
//  WW    WW    WW   WW  W WW WW   WW      WW    WW  W WW   WWW   WWW
//  WW     WWW W WW  WW   WWW WW    WWW     WWW WWWW  WWW WWWW  WWWW 
//                                                                   
//'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

#ifndef TEXTURECLASS
#define TEXTURECLASS

#include "Main.h"

class Texture {
public:
  int wrapS;
  int wrapT;
  int model;
  int numComps;
  int bumpMap;
  float bumpScale;

  const unsigned char *img;  // original data (also index into ass. arrays)
  unsigned char *imgTexture; // corrected map
  unsigned char *imgNormal;  // normal map
  
  SbVec2s size;
  SbColor blend;
  float stex[3], ttex[3];
  typedef map<const unsigned char *, unsigned char *> PointerMap;
  static PointerMap texture_maps;
  static PointerMap normal_maps;
  void addTextureMap(const unsigned char *img,
		     int numComps, SbVec2s size,
		     unsigned char *&imgTexture,
		     unsigned char *&imgNormal);

  Texture();
  ~Texture();
  Texture(int s, int t, int m,
	  SbColor b, int n,  SbVec2s &siz,
	  const unsigned char *i, int _bumpMap, float _bumpScale);
  SbColor getColor(const unsigned char *img, int numComps,
		   float s, float t,
		   SbColor &color);
  SbColor getColor(const SbVec3f &bc, const SbColor diffuse[3]);
  SbVec3f getNormal(const SbVec3f &bc);
};

#endif /* TEXTURECLASS */
