//WWWWWW'''''''WW''''''''''''''''WWW'''''''WW''''WW''''''''WW''''''''''WWW''
//  WW                            WW       WW              WW           WW  
//  WW    W WW WW  WWW WWW   WWW  WW   WW  WW    WW  WWWW WWWW     WWW  WW  
//  WW    WW   WW W WW WW W W WW  WW  WWWW WW    WW WWW    WW     WW W  WW  
//  WW    WW   WW W WW WW W W WW  WW  WW   WW    WW   WWW  WW     WW    WW  
//  WW    WW   WW  WWW WW W  WWW WWWW  WWW WWWWW WW WWWW   WW      WWW WWWW 
//                            WW                                            
//''''''''''''''''''''''''''WWW'''''''''''''''''''''''''''''''''''''''''''''

#ifndef TRIANGLELISTCLASS
#define TRIANGLELISTCLASS

#include "Main.h"
#include "Triangle.h"
class Ray; // forward declaration of Ray class

//#define EPSILON_MRT 0.003  // 0.00003 gives acne (Minimum Ray t)
#define EPSILON_MRT 0.0  // 0.00003 gives acne (Minimum Ray t)

class TriangleList {
private:
  const static char first_surf[16];
  vector<Triangle *> trilist;
  inline int first(const SbVec3f &dir, const Triangle *tri1, const Triangle *tri2);
  
public:

  ~TriangleList(){
    trilist.clear();
  }
 
  // Methods to add triangles 
  void add(Triangle *t){
    trilist.push_back(t);
  }

  void deleteContents();
  
  void clear(){
    trilist.clear();
  }
  
  void drawAll();
  
  // intersection test
  int intersect_ray(Ray &r, Triangle *ignoreTri = NULL);

  int size(){
    return(trilist.size());
  }

  // iterators
  vector<Triangle *>::iterator begin(){
    return(trilist.begin());
  }
  
  vector<Triangle *>::iterator end(){
    return(trilist.end());
  }

  Triangle *operator[](int i){
    return(trilist[i]);
  }
  
};

#endif /* TRIANGLELISTCLASS */
