//WWWW'''''''WW''''''''''''''''''WW''''''''''''''WW''W'''WW'''''
//WW  W      WW                                  WW  W   WW     
//WW  W  WW  WWW  W WW  WWW  WWW WW WWW   WWW    WW  W  WWW W WW
//WW  W WWWW WW W W WW W WW W WW WW WW W W WW    WWWWW W WW WW  
//WW  W WW   WW W W WW W WW W WW WW WW W W WW    WW  W W WW WW  
//WWWW   WWW WWW   WWW  WWW  WWW WW WW W  WWW    WW  W  WWW WW  
//                       WW   WW           WW                   
//'''''''''''''''''''''WWW''WWW''''''''''WWW''''''''''''''''''''

#ifndef DEBUGFUNCS
#define DEBUGFUNCS

#include <stdarg.h>
#include "Main.h"

inline static void printCol(SbColor x){
  cerr << "(";
  cerr << setiosflags(ios::showpoint | ios::fixed) << setprecision(8);
  cerr << x[X] << ", ";
  cerr << x[Y] << ", ";
  cerr << x[Z] << ") " << flush;
  return;
}

ostream& operator<< (ostream& os, const SbVec3f& x);

inline static void printVec(SbVec3f x){
  printCol(SbColor(x));
}


void complain(int line);
void showPoint(SbVec3f p, double radius, SbColor c = SbColor(-1,-1,-1));
long delay (struct timeval t1, struct timeval t2);
void showCube(SbVec3f min, SbVec3f max, SbVec3f c, int clear=0);
void showPhoton(SbVec3f p, SbColor c = SbColor(1.0, 1.0, 1.0), int clear=0);
void print(char const *fmt, ...);
void drawHist(float *flux_map, int n_phi, int n_theta, float scale,
	      SbVec3f x, SbVec3f n);


#endif /* DEBUGFUNCS */
